# coding: utf-8

"""
    Speechall API

    The Speechall REST API provides powerful and flexible speech-to-text capabilities. It allows you to transcribe audio files using various underlying STT providers and models, optionally apply custom text replacement rules, and access results in multiple formats. The API includes standard endpoints for transcription and endpoints compatible with the OpenAI API structure. 

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class TranscriptOutputFormat(str, Enum):
    """
    Specifies the desired format of the transcription output. - `text`: Plain text containing the full transcription. - `json_text`: A simple JSON object containing the transcription ID and the full text (`TranscriptionOnlyText` schema). - `json`: A detailed JSON object including segments, timestamps (based on `timestamp_granularity`), language, and potentially speaker labels and provider metadata (`TranscriptionDetailed` schema). - `srt`: SubRip subtitle format (returned as plain text). - `vtt`: WebVTT subtitle format (returned as plain text). 
    """

    """
    allowed enum values
    """
    TEXT = 'text'
    JSON_TEXT = 'json_text'
    JSON = 'json'
    SRT = 'srt'
    VTT = 'vtt'

    @classmethod
    def from_json(cls, json_str: str) -> TranscriptOutputFormat:
        """Create an instance of TranscriptOutputFormat from a JSON string"""
        return TranscriptOutputFormat(json.loads(json_str))


