# coding: utf-8

"""
    Speechall API

    The Speechall REST API provides powerful and flexible speech-to-text capabilities. It allows you to transcribe audio files using various underlying STT providers and models, optionally apply custom text replacement rules, and access results in multiple formats. The API includes standard endpoints for transcription and endpoints compatible with the OpenAI API structure. 

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class TranscriptionModelIdentifier(str, Enum):
    """
    Unique identifier for a specific Speech-to-Text model, composed as `provider.model_name`. Used to select the engine for transcription.
    """

    """
    allowed enum values
    """
    AMAZON_DOT_TRANSCRIBE = 'amazon.transcribe'
    ASSEMBLYAI_DOT_BEST = 'assemblyai.best'
    ASSEMBLYAI_DOT_NANO = 'assemblyai.nano'
    ASSEMBLYAI_DOT_SLAM_MINUS_1 = 'assemblyai.slam-1'
    ASSEMBLYAI_DOT_UNIVERSAL = 'assemblyai.universal'
    AZURE_DOT_STANDARD = 'azure.standard'
    CLOUDFLARE_DOT_WHISPER = 'cloudflare.whisper'
    CLOUDFLARE_DOT_WHISPER_MINUS_LARGE_MINUS_V3_MINUS_TURBO = 'cloudflare.whisper-large-v3-turbo'
    CLOUDFLARE_DOT_WHISPER_MINUS_TINY_MINUS_EN = 'cloudflare.whisper-tiny-en'
    DEEPGRAM_DOT_BASE = 'deepgram.base'
    DEEPGRAM_DOT_BASE_MINUS_CONVERSATIONALAI = 'deepgram.base-conversationalai'
    DEEPGRAM_DOT_BASE_MINUS_FINANCE = 'deepgram.base-finance'
    DEEPGRAM_DOT_BASE_MINUS_GENERAL = 'deepgram.base-general'
    DEEPGRAM_DOT_BASE_MINUS_MEETING = 'deepgram.base-meeting'
    DEEPGRAM_DOT_BASE_MINUS_PHONECALL = 'deepgram.base-phonecall'
    DEEPGRAM_DOT_BASE_MINUS_VIDEO = 'deepgram.base-video'
    DEEPGRAM_DOT_BASE_MINUS_VOICEMAIL = 'deepgram.base-voicemail'
    DEEPGRAM_DOT_ENHANCED = 'deepgram.enhanced'
    DEEPGRAM_DOT_ENHANCED_MINUS_FINANCE = 'deepgram.enhanced-finance'
    DEEPGRAM_DOT_ENHANCED_MINUS_GENERAL = 'deepgram.enhanced-general'
    DEEPGRAM_DOT_ENHANCED_MINUS_MEETING = 'deepgram.enhanced-meeting'
    DEEPGRAM_DOT_ENHANCED_MINUS_PHONECALL = 'deepgram.enhanced-phonecall'
    DEEPGRAM_DOT_NOVA = 'deepgram.nova'
    DEEPGRAM_DOT_NOVA_MINUS_GENERAL = 'deepgram.nova-general'
    DEEPGRAM_DOT_NOVA_MINUS_PHONECALL = 'deepgram.nova-phonecall'
    DEEPGRAM_DOT_NOVA_MINUS_2 = 'deepgram.nova-2'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_ATC = 'deepgram.nova-2-atc'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_AUTOMOTIVE = 'deepgram.nova-2-automotive'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_CONVERSATIONALAI = 'deepgram.nova-2-conversationalai'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_DRIVETHRU = 'deepgram.nova-2-drivethru'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_FINANCE = 'deepgram.nova-2-finance'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_GENERAL = 'deepgram.nova-2-general'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_MEDICAL = 'deepgram.nova-2-medical'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_MEETING = 'deepgram.nova-2-meeting'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_PHONECALL = 'deepgram.nova-2-phonecall'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_VIDEO = 'deepgram.nova-2-video'
    DEEPGRAM_DOT_NOVA_MINUS_2_MINUS_VOICEMAIL = 'deepgram.nova-2-voicemail'
    DEEPGRAM_DOT_NOVA_MINUS_3 = 'deepgram.nova-3'
    DEEPGRAM_DOT_NOVA_MINUS_3_MINUS_GENERAL = 'deepgram.nova-3-general'
    DEEPGRAM_DOT_NOVA_MINUS_3_MINUS_MEDICAL = 'deepgram.nova-3-medical'
    DEEPGRAM_DOT_WHISPER = 'deepgram.whisper'
    DEEPGRAM_DOT_WHISPER_MINUS_BASE = 'deepgram.whisper-base'
    DEEPGRAM_DOT_WHISPER_MINUS_LARGE = 'deepgram.whisper-large'
    DEEPGRAM_DOT_WHISPER_MINUS_MEDIUM = 'deepgram.whisper-medium'
    DEEPGRAM_DOT_WHISPER_MINUS_SMALL = 'deepgram.whisper-small'
    DEEPGRAM_DOT_WHISPER_MINUS_TINY = 'deepgram.whisper-tiny'
    FALAI_DOT_ELEVENLABS_MINUS_SPEECH_MINUS_TO_MINUS_TEXT = 'falai.elevenlabs-speech-to-text'
    FALAI_DOT_SPEECH_MINUS_TO_MINUS_TEXT = 'falai.speech-to-text'
    FALAI_DOT_WHISPER = 'falai.whisper'
    FALAI_DOT_WIZPER = 'falai.wizper'
    FIREWORKSAI_DOT_WHISPER_MINUS_V3 = 'fireworksai.whisper-v3'
    FIREWORKSAI_DOT_WHISPER_MINUS_V3_MINUS_TURBO = 'fireworksai.whisper-v3-turbo'
    GLADIA_DOT_STANDARD = 'gladia.standard'
    GOOGLE_DOT_ENHANCED = 'google.enhanced'
    GOOGLE_DOT_STANDARD = 'google.standard'
    GEMINI_DOT_GEMINI_MINUS_2_DOT_5_MINUS_FLASH_MINUS_PREVIEW_MINUS_05_MINUS_20 = 'gemini.gemini-2.5-flash-preview-05-20'
    GEMINI_DOT_GEMINI_MINUS_2_DOT_5_MINUS_PRO_MINUS_PREVIEW_MINUS_06_MINUS_05 = 'gemini.gemini-2.5-pro-preview-06-05'
    GEMINI_DOT_GEMINI_MINUS_2_DOT_0_MINUS_FLASH = 'gemini.gemini-2.0-flash'
    GEMINI_DOT_GEMINI_MINUS_2_DOT_0_MINUS_FLASH_MINUS_LITE = 'gemini.gemini-2.0-flash-lite'
    GROQ_DOT_DISTIL_MINUS_WHISPER_MINUS_LARGE_MINUS_V3_MINUS_EN = 'groq.distil-whisper-large-v3-en'
    GROQ_DOT_WHISPER_MINUS_LARGE_MINUS_V3 = 'groq.whisper-large-v3'
    GROQ_DOT_WHISPER_MINUS_LARGE_MINUS_V3_MINUS_TURBO = 'groq.whisper-large-v3-turbo'
    IBM_DOT_STANDARD = 'ibm.standard'
    OPENAI_DOT_WHISPER_MINUS_1 = 'openai.whisper-1'
    OPENAI_DOT_GPT_MINUS_4O_MINUS_TRANSCRIBE = 'openai.gpt-4o-transcribe'
    OPENAI_DOT_GPT_MINUS_4O_MINUS_MINI_MINUS_TRANSCRIBE = 'openai.gpt-4o-mini-transcribe'
    REVAI_DOT_MACHINE = 'revai.machine'
    REVAI_DOT_FUSION = 'revai.fusion'
    SPEECHMATICS_DOT_ENHANCED = 'speechmatics.enhanced'
    SPEECHMATICS_DOT_STANDARD = 'speechmatics.standard'

    @classmethod
    def from_json(cls, json_str: str) -> TranscriptionModelIdentifier:
        """Create an instance of TranscriptionModelIdentifier from a JSON string"""
        return TranscriptionModelIdentifier(json.loads(json_str))


