# coding: utf-8

"""
    Speechall API

    The Speechall REST API provides powerful and flexible speech-to-text capabilities. It allows you to transcribe audio files using various underlying STT providers and models, optionally apply custom text replacement rules, and access results in multiple formats. The API includes standard endpoints for transcription and endpoints compatible with the OpenAI API structure. 

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class TranscriptionProvider(str, Enum):
    """
    The identifier for the underlying Speech-to-Text service provider (e.g., 'openai', 'deepgram').
    """

    """
    allowed enum values
    """
    AMAZON = 'amazon'
    ASSEMBLYAI = 'assemblyai'
    AZURE = 'azure'
    CLOUDFLARE = 'cloudflare'
    DEEPGRAM = 'deepgram'
    FALAI = 'falai'
    FIREWORKSAI = 'fireworksai'
    GEMINI = 'gemini'
    GLADIA = 'gladia'
    GOOGLE = 'google'
    GROQ = 'groq'
    IBM = 'ibm'
    OPENAI = 'openai'
    REVAI = 'revai'
    SPEECHMATICS = 'speechmatics'

    @classmethod
    def from_json(cls, json_str: str) -> TranscriptionProvider:
        """Create an instance of TranscriptionProvider from a JSON string"""
        return TranscriptionProvider(json.loads(json_str))


