# coding: utf-8

"""
    Speechall API

    The Speechall REST API provides powerful and flexible speech-to-text capabilities. It allows you to transcribe audio files using various underlying STT providers and models, optionally apply custom text replacement rules, and access results in multiple formats. The API includes standard endpoints for transcription and endpoints compatible with the OpenAI API structure. 

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class TranscriptionWord(BaseModel):
    """
    Represents a word in the transcription, providing time-coded chunks of the transcription.  # noqa: E501
    """
    start: Union[StrictFloat, StrictInt] = Field(default=..., description="The start time of the word in seconds from the beginning of the audio.")
    end: Union[StrictFloat, StrictInt] = Field(default=..., description="The end time of the word in seconds from the beginning of the audio.")
    word: StrictStr = Field(default=..., description="The transcribed word.")
    speaker: Optional[StrictStr] = Field(default=None, description="An identifier for the speaker of this word, present if diarization was enabled and successful.")
    confidence: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The model's confidence score for the transcription of this word, typically between 0 and 1 (if provided by the model).")
    __properties = ["start", "end", "word", "speaker", "confidence"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TranscriptionWord:
        """Create an instance of TranscriptionWord from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TranscriptionWord:
        """Create an instance of TranscriptionWord from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TranscriptionWord.parse_obj(obj)

        _obj = TranscriptionWord.parse_obj({
            "start": obj.get("start"),
            "end": obj.get("end"),
            "word": obj.get("word"),
            "speaker": obj.get("speaker"),
            "confidence": obj.get("confidence")
        })
        return _obj


